metabrainz/__init__.py
import os
import pprint
import subprocess
import sys

import stripe
from brainzutils.flask import CustomFlask
from flask import send_from_directory, request
from metabrainz.admin.quickbooks.views import QuickBooksView
from time import sleep

# Check to see if we're running under a docker deployment. If so, don't second guess
# the config file setup and just wait for the correct configuration to be generated.
deploy_env = os.environ.get('DEPLOY_ENV', '')

CONSUL_CONFIG_FILE_RETRY_COUNT = 10

def create_app(debug=None, config_path = None):

    app = CustomFlask(
        import_name=__name__,
        use_flask_uuid=True,
    )

    # get rid of some really pesky warning. Remove this in April 2020, when it shouldn't be needed anymore.
    app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = True

    print("Starting metabrainz service with %s environment." % deploy_env);

    # This is used to run tests, but not for dev or deployment
    if config_path:
        print("loading %s" % config_path)
        app.config.from_pyfile(config_path)
    else:
        if not deploy_env:
            print("loading %s" % os.path.join( os.path.dirname(os.path.realpath(__file__)), '..', 'config.py'))
            app.config.from_pyfile(os.path.join(
                os.path.dirname(os.path.realpath(__file__)),
                '..', 'config.py'
            ))

    # Load configuration files: If we're running under a docker deployment, wait until 
    # the consul configuration is available.
    if deploy_env:
        consul_config = os.path.join( os.path.dirname(os.path.realpath(__file__)), 
            '..', 'consul_config.py')

        print("loading consul %s" % consul_config)
        for i in range(CONSUL_CONFIG_FILE_RETRY_COUNT):
            if not os.path.exists(consul_config):
                sleep(1)
                    
        if not os.path.exists(consul_config):
            print("No configuration file generated yet. Retried %d times, exiting." % CONSUL_CONFIG_FILE_RETRY_COUNT);
            sys.exit(-1)

        app.config.from_pyfile(consul_config, silent=True)

    if debug is not None:
        app.debug = debug

    if app.debug and app.config['SECRET_KEY']:
        app.init_debug_toolbar()

    # Printing out some debug values such as config and git commit
    try:
        with open(".git-version") as f:
            git_version = f.read()
        print('Running on git commit %s' % git_version.strip())
    except IOError:
        print("Unable to retrieve git commit. Use docker/push.sh to push images for production.")

    print('Configuration values are as follows: ')
    print(pprint.pformat(app.config, indent=4))

    app.init_loggers(
        file_config=app.config.get('LOG_FILE'),
        sentry_config=app.config.get('LOG_SENTRY'),
    )

    # Database
    from metabrainz import db
    db.init_db_engine(app.config["SQLALCHEMY_DATABASE_URI"])
    from metabrainz import model
    model.db.init_app(app)

    # Redis (cache)
    from brainzutils import cache
    cache.init(**app.config['REDIS'])

    # quickbooks module setup
    from metabrainz.admin.quickbooks import quickbooks
    quickbooks.init(app)

    # MusicBrainz OAuth
    from metabrainz.users import login_manager, musicbrainz_login
    login_manager.init_app(app)
    musicbrainz_login.init(
        app.config['MUSICBRAINZ_BASE_URL'],
        app.config['MUSICBRAINZ_CLIENT_ID'],
        app.config['MUSICBRAINZ_CLIENT_SECRET']
    )

    # Templates
    from metabrainz.utils import reformat_datetime
    app.jinja_env.filters['datetime'] = reformat_datetime
    app.jinja_env.filters['nl2br'] = lambda val: val.replace('\n', '<br />') if val else ''

    # Error handling
    from metabrainz.errors import init_error_handlers
    init_error_handlers(app)

    add_robots(app)

    from metabrainz import babel
    babel.init_app(app)

    from flask_uploads import configure_uploads
    from metabrainz.admin.forms import LOGO_UPLOAD_SET
    configure_uploads(app, upload_sets=[
        LOGO_UPLOAD_SET,
    ])

    # Blueprints
    _register_blueprints(app)

    # ADMIN SECTION

    from flask_admin import Admin
    from metabrainz.admin.views import HomeView
    admin = Admin(app, index_view=HomeView(name='Pending users'), template_mode='bootstrap3')

    # Models
    from metabrainz.model.user import UserAdminView
    from metabrainz.model.payment import PaymentAdminView
    from metabrainz.model.tier import TierAdminView
    admin.add_view(UserAdminView(model.db.session, category='Users', endpoint="user_model"))
    admin.add_view(PaymentAdminView(model.db.session, category='Payments', endpoint="payment_model"))
    admin.add_view(TierAdminView(model.db.session, endpoint="tier_model"))

    # Custom stuff
    from metabrainz.admin.views import CommercialUsersView
    from metabrainz.admin.views import UsersView
    from metabrainz.admin.views import PaymentsView
    from metabrainz.admin.views import TokensView
    from metabrainz.admin.views import StatsView
    admin.add_view(CommercialUsersView(name='Commercial users', category='Users'))
    admin.add_view(UsersView(name='Search', category='Users'))
    admin.add_view(PaymentsView(name='All', category='Payments'))
    admin.add_view(TokensView(name='Access tokens', category='Users'))
    admin.add_view(StatsView(name='Statistics', category='Statistics'))
    admin.add_view(StatsView(name='Top IPs', endpoint="statsview/top-ips", category='Statistics'))
    admin.add_view(StatsView(name='Top Tokens', endpoint="statsview/top-tokens", category='Statistics'))
    admin.add_view(StatsView(name='Supporters', endpoint="statsview/supporters", category='Statistics'))

    if app.config["QUICKBOOKS_CLIENT_ID"]:
        admin.add_view(QuickBooksView(name='Invoices', endpoint="quickbooks/", category='Quickbooks'))

    stripe.api_key = app.config["STRIPE_KEYS"]["SECRET"]

    return app


def add_robots(app):
    @app.route('/robots.txt')
    def static_from_root():
        return send_from_directory(app.static_folder, request.path[1:])


def _register_blueprints(app):
    from metabrainz.views import index_bp
    from metabrainz.reports.financial_reports.views import financial_reports_bp
    from metabrainz.reports.annual_reports.views import annual_reports_bp
    from metabrainz.users.views import users_bp
    from metabrainz.payments.views import payments_bp
    from metabrainz.payments.paypal.views import payments_paypal_bp
    from metabrainz.payments.stripe.views import payments_stripe_bp

    app.register_blueprint(index_bp)
    app.register_blueprint(financial_reports_bp, url_prefix='/finances')
    app.register_blueprint(annual_reports_bp, url_prefix='/reports')
    app.register_blueprint(users_bp)
    app.register_blueprint(payments_bp)
    # FIXME(roman): These URLs aren't named very correct since they receive payments
    # from organizations as well as regular donations:
    app.register_blueprint(payments_paypal_bp, url_prefix='/donations/paypal')
    app.register_blueprint(payments_stripe_bp, url_prefix='/donations/stripe')

    #############
    # OAuth / API
    #############

    from metabrainz.oauth.views import oauth_bp
    app.register_blueprint(oauth_bp, url_prefix='/oauth')
    from metabrainz.api.views.index import api_index_bp
    app.register_blueprint(api_index_bp, url_prefix='/api')
    from metabrainz.api.views.user import api_user_bp
    app.register_blueprint(api_user_bp, url_prefix='/api/user')
    from metabrainz.api.views.musicbrainz import api_musicbrainz_bp
    app.register_blueprint(api_musicbrainz_bp, url_prefix='/api/musicbrainz')

metabrainz/admin/__init__.py
from flask_admin import BaseView, AdminIndexView as IndexView
from flask_admin.contrib.sqla import ModelView
from flask_login import current_user
from flask import request, redirect, url_for, current_app


class AuthMixin(object):
    """All admin views that shouldn't be available to public, must subclass this."""

    def is_accessible(self):
        return current_user.is_authenticated and current_user.musicbrainz_id in current_app.config['ADMINS']

    def _handle_view(self, name, **kwargs):
        if not self.is_accessible():
            return redirect(url_for('users.login', next=request.url))


class AdminBaseView(AuthMixin, BaseView): pass
class AdminModelView(AuthMixin, ModelView): pass
class AdminIndexView(AuthMixin, IndexView): pass

metabrainz/api/views/index.py
from flask import Blueprint, render_template

api_index_bp = Blueprint('api_index', __name__)


@api_index_bp.route('/')
def info():
    """This view provides information about using the API."""
    return render_template('api/info.html')

metabrainz/api/views/index_test.py
from metabrainz.testing import FlaskTestCase


class IndexViewsTestCase(FlaskTestCase):

    def test_info(self):
        self.assert200(self.client.get("/api/"))

metabrainz/api/views/musicbrainz.py
from flask import Blueprint, jsonify, send_from_directory, current_app
from flask.helpers import safe_join
from werkzeug.wrappers import Response
from werkzeug.urls import iri_to_uri
from metabrainz.api.decorators import token_required, tracked
import logging
import time
import re
import os

api_musicbrainz_bp = Blueprint('api_musicbrainz', __name__)

NGINX_INTERNAL_LOCATION = '/internal/replication'

MIMETYPE_ARCHIVE_BZ2 = 'application/x-tar-bz2'
MIMETYPE_ARCHIVE_XZ = 'application/x-xz'
MIMETYPE_SIGNATURE = 'text/plain'

# These durations are used to create nagios compatible status codes so we can monitor
# the replication packet stream.
MAX_PACKET_AGE_WARNING = 60 * 60 * 2  # 4 hours
MAX_PACKET_AGE_CRITICAL = 60 * 60 * 6  # 4 hours


@api_musicbrainz_bp.route('/replication-check')
def replication_check():
    """Check that all the replication packets are contiguous and that no packet
    is more than a few hours old. Output a Nagios compatible line of text.
    """

    try:
        entries = [os.path.join(current_app.config['REPLICATION_PACKETS_DIR'], e)
                   for e in os.listdir(current_app.config['REPLICATION_PACKETS_DIR'])]
    except OSError as e:
        logging.warning(e)
        return Response("UNKNOWN " + str(e), mimetype='text/plain')

    pattern = re.compile("replication-[0-9]+.tar.bz2$")
    entries = filter(lambda x: pattern.search(x), entries)
    entries = filter(os.path.isfile, entries)
    entries = _sort_natural(entries)

    if len(entries) == 0:
        return Response("UNKNOWN no replication packets available", mimetype='text/plain')

    resp = "OK"
    last = -1
    pattern = re.compile("replication-([0-9]+).tar.bz2$")
    for entry in entries:
        m = pattern.search(entry)
        if not m:
            resp = "UNKNOWN Unkown files in the replication directory"
            break
        num = int(m.groups()[0])
        if last < 0:
            last = num - 1
        if last != num - 1:
            resp = "CRITICAL Replication packet %d is missing" % (num - 1)
        last = num

    if resp != "OK":
        return Response(resp, mimetype='text/plain')
        
    last_packet_age = time.time() - os.path.getmtime(entries[-1]) 
    if last_packet_age > MAX_PACKET_AGE_CRITICAL:
        resp = "CRITICAL Latest replication packet is %.1f hours old" % (last_packet_age / 3600)
    elif last_packet_age > MAX_PACKET_AGE_WARNING:
        resp = "WARNING Latest replication packet is %.1f hours old" % (last_packet_age / 3600)

    return Response(resp, mimetype='text/plain')


@api_musicbrainz_bp.route('/replication-info')
@token_required
def replication_info():
    """This endpoint returns numbers of the last available replication packets."""

    def _get_last_packet_name(location, pattern):
        try:
            entries = [os.path.join(location, e) for e in os.listdir(location)]
        except OSError as e:
            logging.warning(e)
            return None
        pattern = re.compile(pattern)
        entries = filter(lambda x: pattern.search(x), entries)
        entries = filter(os.path.isfile, entries)
        entries = _sort_natural(entries, reverse=True)  # latest first
        return os.path.split(entries[0])[-1] if entries else None

    # TODO(roman): Cache this response:
    return jsonify({
        'last_packet': _get_last_packet_name(
            current_app.config['REPLICATION_PACKETS_DIR'],
            "replication-[0-9]+.tar.bz2$"
        ),
    })


@api_musicbrainz_bp.route('/replication-<int:packet_number>.tar.bz2')
@token_required
@tracked
def replication_hourly(packet_number):
    directory = current_app.config['REPLICATION_PACKETS_DIR']
    filename = 'replication-%s.tar.bz2' % packet_number
    if not os.path.isfile(safe_join(directory, filename)):
        return Response("Can't find specified replication packet!\n", status=404)

    if 'USE_NGINX_X_ACCEL' in current_app.config and current_app.config['USE_NGINX_X_ACCEL']:
        return _redirect_to_nginx(os.path.join(NGINX_INTERNAL_LOCATION, filename))
    else:
        return send_from_directory(directory, filename, mimetype=MIMETYPE_ARCHIVE_BZ2)


@api_musicbrainz_bp.route('/replication-<int:packet_number>.tar.bz2.asc')
@token_required
def replication_hourly_signature(packet_number):
    directory = current_app.config['REPLICATION_PACKETS_DIR']
    filename = 'replication-%s.tar.bz2.asc' % packet_number
    if not os.path.isfile(safe_join(directory, filename)):
        return Response("Can't find signature for a specified replication packet!\n", status=404)

    if 'USE_NGINX_X_ACCEL' in current_app.config and current_app.config['USE_NGINX_X_ACCEL']:
        return _redirect_to_nginx(os.path.join(NGINX_INTERNAL_LOCATION, filename))
    else:
        return send_from_directory(directory, filename, mimetype=MIMETYPE_SIGNATURE)


@api_musicbrainz_bp.route('/json-dumps/json-dump-<int:packet_number>/<entity_name>.tar.xz')
@token_required
@tracked
def json_dump(packet_number, entity_name):
    """Endpoint that provides access to the JSON dump files.

    See MEB-93 for more info.
    """
    directory = os.path.join(current_app.config['JSON_DUMPS_DIR'], "json-dump-%s" % packet_number)
    filename = '%s.tar.xz' % entity_name
    if not os.path.isfile(safe_join(directory, filename)):
        return Response("Can't find specified JSON dump!", status=404)
    return send_from_directory(directory, filename, mimetype=MIMETYPE_ARCHIVE_XZ)


@api_musicbrainz_bp.route('/json-dumps/json-dump-<int:packet_number>/<entity_name>.tar.xz.asc')
@token_required
@tracked
def json_dump_signature(packet_number, entity_name):
    """Endpoint that provides access to the JSON dump signature files.
    """
    directory = os.path.join(current_app.config['JSON_DUMPS_DIR'], "json-dump-%s" % packet_number)
    filename = '%s.tar.xz.asc' % entity_name
    if not os.path.isfile(safe_join(directory, filename)):
        return Response("Can't find signature for the specified JSON dump!", status=404)
    return send_from_directory(directory, filename, mimetype=MIMETYPE_SIGNATURE)


def _redirect_to_nginx(location):
    """This creates an internal redirection to a specified location.

    This feature is only supported by nginx. See http://wiki.nginx.org/X-accel
    for more information about it.
    """
    response = Response(status=200)
    location = iri_to_uri(location, safe_conversion=True)
    response.headers['X-Accel-Redirect'] = location
    return response


def _sort_natural(names_list, reverse=False):
    """Sort list using a natural sort order.

    https://en.wikipedia.org/wiki/Natural_sort_order
    """
    def sort_key(val):
        return [int(s) if s.isdigit() else s for s in re.split(r'(\d+)', val)]

    return sorted(names_list, key=sort_key, reverse=reverse)

metabrainz/api/views/user.py
from flask import Blueprint, jsonify
from metabrainz.oauth import oauth_provider
from metabrainz.model.user import User

api_user_bp = Blueprint('api_user', __name__)


@api_user_bp.route('/')
@oauth_provider.require_auth()
def user(user_id):
    user = User.get(id=user_id)
    return jsonify({
        "username": user.musicbrainz_id,
    })

metabrainz/db/__init__.py
import sqlalchemy
from sqlalchemy import create_engine
from sqlalchemy.pool import NullPool

engine: sqlalchemy.engine.Engine = None


def init_db_engine(connect_str):
    global engine
    engine = create_engine(connect_str, poolclass=NullPool)


def run_sql_script(sql_file_path):
    with open(sql_file_path) as sql:
        with engine.connect() as connection:
            connection.execute(sql.read())


def run_sql_script_without_transaction(sql_file_path):
    with open(sql_file_path) as sql:
        connection = engine.connect().execution_options(isolation_level="AUTOCOMMIT")
        lines = sql.read().splitlines()
        try:
            # If we try to execute multiple statements at once, postgres wraps them in a transaction.
            # see https://www.psycopg.org/docs/usage.html#transactions-control for details.
            for line in lines:
                # TODO: Not a great way of removing comments. The alternative is to catch
                # the exception sqlalchemy.exc.ProgrammingError "can't execute an empty query"
                if line and not line.startswith("--"):
                    connection.execute(line)
        except sqlalchemy.exc.ProgrammingError as e:
            print("Error: {}".format(e))
        finally:
            connection.close()

metabrainz/model/__init__.py
from flask_sqlalchemy import SQLAlchemy

db = SQLAlchemy()

# All models must be imported there:
from .user import User
from .token import Token
from .token_log import TokenLog
from .access_log import AccessLog
from .tier import Tier
from .payment import Payment

metabrainz/oauth/__init__.py
from metabrainz.oauth.provider import MetaBrainzAuthorizationProvider

oauth_provider = MetaBrainzAuthorizationProvider()

metabrainz/templates/base.html
{% from 'macros.html' import print_message %}

<!DOCTYPE html>
<html lang="en">

  <head>
    {% block head %}
      <meta charset="utf-8">
      <title>{% block title %}MetaBrainz Foundation{% endblock %}</title>
      <meta http-equiv="X-UA-Compatible" content="IE=edge" />
      <meta name="viewport" content="width=device-width, initial-scale=1" />

      <link rel="icon" sizes="16x16" href="{{ url_for('static', filename='img/favicon-16.png') }}" type="image/png" />
      <link rel="icon" sizes="32x32" href="{{ url_for('static', filename='img/favicon-32.png') }}" type="image/png" />
      <link rel="icon" sizes="64x64" href="{{ url_for('static', filename='img/favicon-64.png') }}" type="image/png" />
      <link rel="icon" sizes="128x128" href="{{ url_for('static', filename='img/favicon-128.png') }}" type="image/png" />
      <link rel="icon" sizes="256x256" href="{{ url_for('static', filename='img/favicon-256.png') }}" type="image/png" />

      {% if config.USE_COMPILED_STYLING %}
        <link href="{{ url_for('static', filename='css/main.css') }}" rel="stylesheet" media="screen" />
      {% else %}
        <link rel="stylesheet/less" type="text/css" href="{{ url_for('static', filename='css/main.less') }}" />
        <script src="{{ url_for('static', filename='js/less-1.7.5.min.js') }}"></script>
      {% endif %}
    {% endblock %}
  </head>

  <body>
    {% include 'navbar.html' %}

    <div class="container">
      
      {% with messages = get_flashed_messages(with_categories=true) %}
        {% for category, message in messages %}
          {{ print_message(message, category) }}
        {% endfor %}
      {% endwith %}

      {% block content %}
        <!-- Page content -->
      {% endblock %}

      {% block footer %}
        <hr />
        <div class="footer">
          <div class="row">
            <div class="col-sm-2">
              <div class="title"><a href="{{ url_for('index.about') }}">{{ _('Foundation') }}</a></div>
              <ul>
                <li><a href="{{ url_for('index.projects') }}">{{ _('Projects') }}</a></li>
                <li><a href="{{ url_for('index.datasets') }}">{{ _('Datasets') }}</a></li>
                <li><a href="{{ url_for('index.team') }}">{{ _('Team') }}</a></li>
                <li><a href="{{ url_for('index.shop') }}">{{ _('Shop') }}</a></li>
              </ul>
            </div>
            <div class="col-sm-2">
              <div class="title"><a href="{{ url_for('index.about') }}">{{ _('Policies') }}</a></div>
              <ul>
                <li><a href="{{ url_for('index.social_contract') }}">{{ _('Social Contract') }}</a></li>
                <li><a href="{{ url_for('index.code_of_conduct') }}">{{ _('Code of Conduct') }}</a></li>
                <li><a href="{{ url_for('index.privacy_policy') }}">{{ _('Privacy Policy') }}</a></li>
              </ul>
            </div>
            <div class="col-sm-2">
              <div class="title"><a href="{{ url_for('financial_reports.index') }}">{{ _('Finances') }}</a></div>
              <ul>
                <li><a href="{{ url_for('annual_reports.index') }}">{{ _('Annual Reports') }}</a></li>
                <li><a href="{{ url_for('payments.donors') }}">{{ _('Donors') }}</a></li>
                <li><a href="{{ url_for('index.sponsors') }}">{{ _('Sponsors') }}</a></li>
                <li><a href="{{ url_for('users.supporters_list') }}">{{ _('Supporters') }}</a></li>
              </ul>
            </div>
            <div class="col-sm-2">
              <div class="title"><a href="{{ url_for('users.supporters_list') }}">{{ _('Users') }}</a></div>
              <ul>
                {% if not current_user or current_user.is_anonymous %}
                  <li><a href="{{ url_for('users.login') }}">{{ _('Sign in') }}</a></li>
                {% else %}
                  <li><a href="{{ url_for('users.logout') }}">{{ _('Sign out') }}</a></li>
                {% endif %}
                <li><a href="{{ url_for('users.profile') }}">{{ _('Access your account') }}</a></li>
                <li><a href="{{ url_for('api_index.info') }}">{{ _('API') }}</a></li>
              </ul>
            </div>
            {# Last block should fill up the rest of this row. #}
            <div class="col-sm-4">
              <div class="title"><a href="{{ url_for('index.contact') }}">{{ _('Contact us') }}</a></div>
              <ul>
                <li><a href="https://blog.metabrainz.org/category/metabrainz/">{{ _('Blog') }}</a></li>
                <li><a href="https://twitter.com/MetaBrainz">{{ _('Twitter') }}</a></li>
              </ul>
            </div>
          </div>
          <div class="lower-footer">
            {{ _('Sponsored by <a href="%(google_url)s">Google</a>,
            <a href="%(osuosl_url)s">OSUOSL</a> and
            <a href="%(sponsors_url)s">others&hellip;</a>',
            sponsors_url=url_for('index.sponsors'),
            osuosl_url='https://osuosl.org/',
            google_url='https://www.google.com/') }}
          </div>
        </div>
      {% endblock %}

    </div>

    {% block scripts %}
      <script src="{{ url_for('static', filename='js/jquery-2.1.1.min.js') }}"></script>
      <script src="{{ url_for('static', filename='js/bootstrap.min.js') }}"></script>
    {% endblock %}

  </body>

</html>

metabrainz/templates/macros.html
{% macro print_message(message, category) %}
  {% if category == "error" %}
    {% set alert_class="alert-danger" %}
  {% elif category == "warning" %}
    {% set alert_class="alert-warning" %}
  {% elif category == "success" %}
    {% set alert_class="alert-success" %}
  {% else %}
    {% set alert_class="alert-info" %}
  {% endif %}

  <div class="alert {{ alert_class }}">{{ message }}</div>
{% endmacro %}

{% macro oauth_scope_desc(scope) %}
  {###

  Define scope description here like this:

  {% if scope == "review" %}
    <abbr title="Create and modify your reviews.">{{ _('Reviews') }}</abbr>
  {% elif scope == "profile" %}
    <abbr title="Access your profile">{{ _('Profile') }}</abbr>
  {% endif %}

  ###}
{% endmacro %}

metabrainz/templates/navbar.html
<nav class="navbar navbar-default navbar-static-top MetaBrainz" role="navigation">
  <div class="container">

    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header">
      <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#mb-navbar-collapse">
        <span class="sr-only">{{ _('Toggle navigation') }}</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <a class="navbar-brand logo" href="{{ url_for('index.home') }}">
        <img src="{{ url_for('static', filename='img/navbar_logo.svg') }}" alt="MetaBrainz Foundation" />
      </a>
    </div>

    <!-- Collect the nav links, forms, and other content for toggling -->
    <div class="collapse navbar-collapse" id="mb-navbar-collapse">
      <ul class="nav navbar-nav">
        <li class="dropdown">
          <a class="dropdown-toggle" data-toggle="dropdown" href="#">{{ _('About ') }}<span class="caret"></span></a>
          <ul class="dropdown-menu" role="menu">
            <li><a href="{{ url_for('index.about') }}">{{ _('The Foundation') }}</a></li>
            <li><a href="{{ url_for('index.projects') }}">{{ _('Projects') }}</a></li>
            <li><a href="{{ url_for('index.datasets') }}">{{ _('Datasets') }}</a></li>
            <li><a href="{{ url_for('index.team') }}">{{ _('Team') }}</a></li>
            <li><a href="{{ url_for('index.shop') }}">{{ _('Shop') }}</a></li>
          </ul>
        </li>

        <li class="dropdown">
          <a class="dropdown-toggle" data-toggle="dropdown" href="#">{{ _('Policies ') }}<span class="caret"></span></a>
          <ul class="dropdown-menu" role="menu">
            <li><a href="{{ url_for('index.social_contract') }}">{{ _('Social Contract') }}</a></li>
            <li><a href="{{ url_for('index.code_of_conduct') }}">{{ _('Code of Conduct') }}</a></li>
            <li><a href="{{ url_for('index.privacy_policy') }}">{{ _('Privacy Policy') }}</a></li>
            <li><a href="{{ url_for('index.conflict_policy') }}">{{ _('Conflict Resolution Policy') }}</a></li>
            <li><a href="{{ url_for('index.gdpr_statement') }}">{{ _('GDPR Compliance') }}</a></li>
          </ul>
        </li>

        <li><a href="{{ url_for('users.supporters_list') }}">{{ _('Supporters') }}</a></li>
        <li><a href="{{ url_for('index.sponsors') }}">{{ _('Sponsors') }}</a></li>
        <li class="dropdown">
          <a class="dropdown-toggle" data-toggle="dropdown" href="#">{{ _('Reports ') }}<span class="caret"></span></a>
          <ul class="dropdown-menu" role="menu">
            <li><a href="{{ url_for('annual_reports.index') }}">{{ _('Annual Reports') }}</a></li>
            <li><a href="{{ url_for('financial_reports.index') }}">{{ _('Financial Reports') }}</a></li>
            <li><a href="{{ url_for('payments.donors') }}">{{ _('Donors') }}</a></li>
          </ul>
        </li>
        <li><a href="{{ url_for('payments.donate') }}">{{ _('Donate') }}</a></li>
      </ul>

      {# Not showing user stuff on error pages. If attempt to load user info fails there, page will not render. #}
      {% if not error %}
        <ul class="nav navbar-nav navbar-right">
          {% if not current_user or current_user.is_anonymous %}
            <li class="support-link"><a href="{{ url_for('users.account_type') }}">{{ _('Register') }}</a></li>
            <li><a href="{{ url_for('users.login') }}">{{ _('Sign in') }}</a></li>
          {% else %}
            <li class="dropdown">
              <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                {{ current_user.musicbrainz_id }} <span class="caret"></span>
              </a>
              <ul class="dropdown-menu" role="menu">
                <li><a href="{{ url_for('users.profile', musicbrainz_id=current_user.musicbrainz_id) }}">{{ _('Your profile') }}</a></li>
                <li><a href="{{ url_for('users.logout') }}">{{ _('Sign out') }}</a></li>
              </ul>
            </li>
          {% endif %}
        </ul>
      {%- endif -%}
    </div>

  </div>
</nav>